package com.bea.examples.web;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import examples.simple.webutils.WebAppUtils;

/**
 * The HelloWorldServlet demonstrates creating HTML output in a servlet class.
 *
*/

public class HelloWorldServlet extends HttpServlet {

  public void init(ServletConfig config) throws ServletException  {
    super.init(config);
    log("\n\n****************************\n"
        +init ear 1"
        +"\n*****************************\n\n");
  }

  /**
   * A very simple implementation of the service method, 
   * which outputs the contents of a static HTML page
   */
  public void service(HttpServletRequest req, HttpServletResponse res)
       throws IOException
  {
    // Must set the content type first
    res.setContentType("text/html");
    // Now we can obtain a PrintWriter
    PrintWriter out = res.getWriter();
    
    out.println("<html><head><title>Hello World!</title></head>");
    out.println("<body>");
    out.println("<h1>Hello World I am the HULK!</h1>");
    out.println("<h2>You are using browser: " 
                + WebAppUtils.getBrowserName(req) + " </h2></body></html>");
    // Do not close the output stream - allow the servlet engine to close it
    // to enable better performance.
  }
}
