package extra;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;


public class RedirectFilter implements Filter {
  
  private boolean debug = false;
  
  public void init(FilterConfig filterConfig) throws ServletException { /* no op */ }
  
  public void destroy() { /* no op */ }
  
  /* Take any request matching this URI (the filter is mapped to this same URI)
   *you can imagine abstrating this to have a simple mapping of URL from -- URL to 
     
  <filter>
  <filter-name>RedirectFilter</filter-name>
  <filter-class>extra.RedirectFilter</filter-class>
  </filter>
  
  <filter-mapping>
  <filter-name>RedirectFilter</filter-name>
  <url-pattern>/internal/releases/diablo/*</url-pattern>
  </filter-mapping>
  */
  static String uriBit = "/internal/releases/diablo";
  public void doFilter(ServletRequest req,
                       ServletResponse res,
                       FilterChain chain)
    throws java.io.IOException, ServletException {
    try {
      HttpServletRequest request = (HttpServletRequest)req;
      setDebug(request);
      HttpServletResponse response = (HttpServletResponse)res;
      String uri = request.getRequestURI();
      if(uri.indexOf(uriBit) != -1 && needToRedirect(uri)) {
        if(debug){
          System.out.println("uri is " + request.getRequestURI());
        }
        response.sendRedirect(getRedirectURI(uri));
        return;
      }
    }catch (ClassCastException neverHappen) {
      neverHappen.printStackTrace();
    }
    chain.doFilter(req, res);
  }
  
  private void setDebug(HttpServletRequest request) {
    String debugStr = (String)request.getAttribute("debug");
    if(debugStr != null && debugStr.equalsIgnoreCase("true")) {
      debug = true;
    } else if (debugStr != null && debugStr.equalsIgnoreCase("false")) {
      debug = false;
    }
  }
  
  private boolean needToRedirect(String uri) {
    if(uri.lastIndexOf(".html") != -1 || uri.lastIndexOf(".htm") != -1) {
      if(debug){
        System.out.println("needToRedirect is " + uri);
      }
      return true;
    }
    return false;
  }
  
  /*
   * make the diablo part Diablo
   */
  private String getRedirectURI(String uri) {
    String preURIStub = uri.substring(0,19); //"/internal/releases/"
    if(debug){
      System.out.println("pre-redirect uri is " + preURIStub);
    }
    String postURIStub = uri.substring(25, uri.length()); //"/internal/releases/Diablo"
    if(debug){
      System.out.println("post-redirect uri is " + postURIStub);
    }
    String redirectURI = preURIStub + "Diablo" + postURIStub;
    if(debug){
      System.out.println("redirect uri is " + redirectURI);
    }
    return redirectURI;
  }
}
